;
;	ClientDialogs.asm
;

.386
.model flat, stdcall
option casemap:none

; ------------------------------------------------------------

include Client.inc

; ------------------------------------------------------------

.const

.data

.data?

; ------------------------------------------------------------

.code

; ------------------------------------------------------------
; DlgConnectProc PROTO :HWND, :DWORD, :DWORD, :DWORD
;		Description: prompts user for host addr in standard
;			internet dot notation, e.g., 127.0.0.1. Note, the
;			default is the loopback value.
;		Return: nothing.
; ------------------------------------------------------------

DlgConnectProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	LOCAL lpHostAddr :DWORD

	.if uMsg == WM_INITDIALOG
	
		invoke SetWindowLong, hWnd, GWL_USERDATA, lParam

	.elseif uMsg == WM_COMMAND

		mov eax, wParam
		shr eax, 16

		.if ax == BN_CLICKED

			mov eax, wParam

			.if ax == IDCANCEL

				push esi
				assume esi:PTR HOST_ADDR

				invoke GetWindowLong, hWnd, GWL_USERDATA
				mov esi, eax 
				mov [esi].hostAddrStatus, IDCANCEL

				assume esi:nothing
				pop esi

				invoke SendMessage, hWnd, WM_CLOSE, 0, 0

			.elseif ax == IDOK

				push esi
				assume esi:PTR HOST_ADDR

				invoke GetWindowLong, hWnd, GWL_USERDATA
				mov esi, eax ; ptr to the STRUCT HOST_ADDR was returned
	
				mov [esi].hostAddrStatus, IDOK

				push [esi].hostAddrTextPtr
				pop lpHostAddr
				invoke GetDlgItemText, hWnd, IDC_HOST_ADDR_EDIT, \
																			lpHostAddr, DLGTEXT_SIZE-1

				invoke SendMessage, hWnd, WM_CLOSE, 0, 0

				assume esi:nothing
				pop esi

			.endif

		.endif

	.elseif uMsg == WM_CLOSE

		invoke EndDialog, hWnd, 0

	.else

		mov eax, FALSE
		ret

	.endif

	mov eax, TRUE
	ret

DlgConnectProc endp 

; ------------------------------------------------------------
; DlgLoginProc PROTO :HWND, :DWORD, :DWORD, :DWORD
;		Description: prompts user for login name or "handle" to be
;			used as an identifier to other relay server clients. Note:
;			null name not allowed, in addition, may not have embedded
;			blank spaces or be greater than standard name length.
;		Return: nothing.
; ------------------------------------------------------------

DlgLoginProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	LOCAL lpLoginName :DWORD

	.if uMsg == WM_INITDIALOG
	
		invoke SetWindowLong, hWnd, GWL_USERDATA, lParam

	.elseif uMsg == WM_COMMAND

		mov eax, wParam
		shr eax, 16

		.if ax == BN_CLICKED

			mov eax, wParam

			.if ax == IDCANCEL

				push esi
				assume esi:PTR LOGIN_ID

				invoke GetWindowLong, hWnd, GWL_USERDATA
				mov esi, eax 
				mov [esi].loginIdStatus, IDCANCEL

				assume esi:nothing
				pop esi

				invoke SendMessage, hWnd, WM_CLOSE, 0, 0

			.elseif ax == IDOK

				push esi
				assume esi:PTR LOGIN_ID

				invoke GetWindowLong, hWnd, GWL_USERDATA
				mov esi, eax ; ptr to the STRUCT LOGIN_ID was returned
	
				mov [esi].loginIdStatus, IDOK

				push [esi].loginIdTextPtr
				pop lpLoginName
				invoke GetDlgItemText, hWnd, IDC_LOG_NAME_EDIT, \
																			lpLoginName, DLGTEXT_SIZE-1

				invoke SendMessage, hWnd, WM_CLOSE, 0, 0

				assume esi:nothing
				pop esi

			.endif

		.endif

	.elseif uMsg == WM_CLOSE

		invoke EndDialog, hWnd, 0

	.else

		mov eax, FALSE
		ret

	.endif

	mov eax, TRUE
	ret

DlgLoginProc endp 

; ------------------------------------------------------------
; DlgSendMsgProc PROTO :HWND, :DWORD, :DWORD, :DWORD
;		Description: prompts user for name of recipient of
;			data and for message text. Note: the lengths of the 
;			name and text strings may not be 0. Max length of
;			text is 07FFFh, i.e., system default.
;		Return: nothing.
; ------------------------------------------------------------

DlgSendMsgProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	LOCAL lpRecipient :DWORD
	LOCAL lpMessage :DWORD

	.if uMsg == WM_INITDIALOG
	
		invoke SetWindowLong, hWnd, GWL_USERDATA, lParam

	.elseif uMsg == WM_COMMAND

		mov eax, wParam
		shr eax, 16

		.if ax == BN_CLICKED

			mov eax, wParam

			.if ax == IDCANCEL

				push esi
				assume esi:PTR SEND_DATA

				invoke GetWindowLong, hWnd, GWL_USERDATA
				mov esi, eax 
				mov [esi].sendDataStatus, IDCANCEL

				assume esi:nothing
				pop esi

				invoke SendMessage, hWnd, WM_CLOSE, 0, 0

			.elseif ax == IDOK

				push esi
				assume esi:PTR SEND_DATA

				invoke GetWindowLong, hWnd, GWL_USERDATA
				mov esi, eax ; ptr to the STRUCT SEND_DATA was returned
	
				mov [esi].sendDataStatus, IDOK

				push [esi].sendRecipTextPtr
				pop lpRecipient
				invoke GetDlgItemText, hWnd, IDC_RECIPIENT_NAME_EDIT, \
															lpRecipient, DLGTEXT_SIZE-1

				push [esi].sendMsgTextPtr
				pop lpMessage
				invoke GetDlgItemText, hWnd, IDC_SEND_TEXT_EDIT, \
															lpMessage, MAX_MESSAGE_SIZE-1

				invoke SendMessage, hWnd, WM_CLOSE, 0, 0

				assume esi:nothing
				pop esi

			.endif

		.endif

	.elseif uMsg == WM_CLOSE

		invoke EndDialog, hWnd, 0

	.else

		mov eax, FALSE
		ret

	.endif

	mov eax, TRUE
	ret

DlgSendMsgProc endp 

; ------------------------------------------------------------

end
